#include <iostream>

// Exemple de programmation generique


/*
  La declaration suivante cree non pas *une* fonction max, mais une *famille* de
  fonctions max<T> indexee par un type T. max<int> est une fonction renvoyant le
  maximum de deux variables int, max<double> renvoie le maximum de deux
  variables double, et de meme pour tout type pour lequel "<" a un sens.
*/ 
template <typename T>
T max(T x, T y)
{
  if (x<y)
	return y;
  
  return x;
}

int main(void)
{
  // Ici max est interprete comme max<int> (3 et 5 sont des int)
  std::cout << max(3,5)/2 << "\n";

  // Ici max est interprete comme max<double> (3. et 5. sont des double)
  std::cout << max(3.,5.)/2 << "\n";

  // La ligne suivante creerait une erreur : on ne peut pas savoir si la fonction attendue est max<int> ou max<double>
  //std::cout << max(3.,5)/2 << "\n";

  // On peut forcer le type choisi :
  std::cout << max<int>(3.,5)/2 << "\n";
  std::cout << max<double>(3.,5)/2 << "\n";

  std::cout << max<int>(3.5,5.5) << "\n";// Ici, meme si 3.5 et 5.5 sont des doubles, ils sont convertis en int (en prenant donc la partie entiere) et la valeur de retour est 5.

  return 0;
}
