#include <iostream>

// Quand plusieurs fonctions peuvent correspondre a un meme appel, on chosit la fonction la plus specialisee


// Fonction f "tres generique" : les deux arguments sont quelconques
template <typename S, typename T>
void f(S x, T y)
{
  std::cout << "Version 1\n";
}

// Fonction f "intermediaire" : les deux arguments doivent etre de meme types
template <typename T>
void f(T x, T y)
{
  std::cout << "Version 2\n";
}

//  Fonction f "tres specialisee" : les deux arguments doivent etre des double
void f(double x, double y)
{
  std::cout << "Version 3\n";
}

int main(void)
{
  // Deux doubles : les trois fonctions pourraient correspondre, la plus specialisee, c'est-a-dire la version 3, est prioritaire
  f(0.5, 0.5); 

  
  // Deux int : les versions 1 et 2 pourraient etre appelee, la version 2 est prioritaire
  f(0, 0);


  // Deux types differents, seule la version 1 convient.
  f(0.5, 0);
}
